'use strict';

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _expressSession = require('express-session');

var _expressSession2 = _interopRequireDefault(_expressSession);

var _bodyParser = require('body-parser');

var _bodyParser2 = _interopRequireDefault(_bodyParser);

var _expressHandlebars = require('express-handlebars');

var _expressHandlebars2 = _interopRequireDefault(_expressHandlebars);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _connectBusboy = require('connect-busboy');

var _connectBusboy2 = _interopRequireDefault(_connectBusboy);

var _portfinder = require('portfinder');

var _portfinder2 = _interopRequireDefault(_portfinder);

var _cliColor = require('cli-color');

var _cliColor2 = _interopRequireDefault(_cliColor);

var _openurl = require('openurl');

var _openurl2 = _interopRequireDefault(_openurl);

var _cli = require('../cli');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import controllers from './controllers'


var abePort = null;

if (process.env.ROOT) _cli.config.set({ root: process.env.ROOT.replace(/\/$/, '') + '/' });
if (process.env.PORT) abePort = process.env.PORT;
_cli.config.set({ webport: process.env.WEBPORT ? process.env.WEBPORT : 8081 });

var html = _expressHandlebars2.default.create({
  extname: '.' + _cli.config.files.templates.extension,
  helpers: {
    abe: _cli.compileAbe,
    listPage: _cli.listPage,
    math: _cli.math,
    printInput: _cli.printInput,
    abeImport: _cli.abeImport,
    moduloIf: _cli.moduloIf,
    testObj: _cli.testObj,
    notEmpty: _cli.notEmpty,
    printJson: _cli.printJson,
    className: _cli.className,
    attrAbe: _cli.attrAbe,
    folders: _cli.folders,
    printConfig: _cli.printConfig,
    ifIn: _cli.ifIn,
    ifCond: _cli.ifCond
  }
});

_portfinder2.default.getPort(function (err, freePort) {
  var app = (0, _express2.default)();
  var port = abePort !== null ? abePort : freePort || 3000;
  port = _cli.Hooks.instance.trigger('beforeExpress', port);

  app.set('views', _path2.default.join(__dirname, '/templates'));

  // app.set('template', )
  app.engine('.html', html.engine);
  app.set('view engine', '.html');

  app.locals.layout = false;

  app.use(_express2.default.static(__dirname + '/public'));
  _cli.FileParser.copySiteAssets();

  var sites = _cli.FileParser.getFolders(_cli.config.root.replace(/\/$/, ""), false, 0);
  var publish = _cli.fileUtils.concatPath(_cli.config.root, _cli.config.publish.url);
  app.use(_express2.default.static(publish));

  if (_cli.config.partials !== '') {
    if (_cli.fileUtils.isFile(_cli.fileUtils.concatPath(_cli.config.root, _cli.config.partials))) {
      app.use(_express2.default.static(_cli.fileUtils.concatPath(_cli.config.root, _cli.config.partials)));
    }
  }

  var pluginsPartials = _cli.Plugins.instance.getPartials();
  Array.prototype.forEach.call(pluginsPartials, function (pluginPartials) {
    app.use(_express2.default.static(pluginPartials));
  });

  app.use(_express2.default.static(__dirname + '/node_modules/handlebars/dist'));
  app.use((0, _connectBusboy2.default)());
  app.use(_bodyParser2.default.json());
  app.use(_bodyParser2.default.urlencoded({ extended: true }));
  app.use((0, _expressSession2.default)({ secret: _cli.config.sessionSecret, resave: false, saveUninitialized: true }));
  _cli.Hooks.instance.trigger('afterExpress', app, _express2.default);

  // important : require here so config.root is defined
  var controllers = require('./controllers');
  app.use(controllers.default);

  app.listen(port, function () {
    console.log(_cliColor2.default.green('\nserver running at http://localhost:' + port + '/'));
    if (process.env.OPENURL) _openurl2.default.open('http://localhost:' + port + '/abe/');
  });
});