import path from 'path'

import {
  Util,
  FileParser,
  fileUtils,
  fileAttr,
  config,
  cli,
  log,
  Page
} from '../'

export default class User {

  constructor(session, query){
    if(typeof query.role !== 'undefined' && query.role !== null) session.role = query.role
    else if(!session.role) session.role = 'admin'

    this._role = session.role
    this._allowed = this.setAllowed()
  }

  setAllowed(){
    var allowed = {
      actions: [],
      workflow: []
    }
    config.actions.forEach((action) => {
      var userActions = config["roles"][this._role]["actions"]
      if(userActions === '*' || userActions.indexOf(action) > -1) allowed["actions"][action] = 1
    })
    var nb = 0;
    var configWorkflow = ['draft'].concat(config.workflow)
    var userFlow = config["roles"][this._role]["workflow"]
    configWorkflow.push('publish')
    var foundFlow = false

    configWorkflow.forEach((flow) => {
      if(userFlow === '*' || flow === userFlow) allowed["workflow_index"] = ++nb
      if(userFlow === '*') allowed["workflow"].push(flow)
      else if(!foundFlow) allowed["workflow"].push(flow)
      if(flow === userFlow) foundFlow = true
    })

    return allowed
  }

  get actions(){
    return this._allowed['actions']
  }

  get workflow(){
    return this._allowed['workflow']
  }

  get workflowIndex(){
    return this._allowed['workflow_index']
  }

  get role(){
    return this._role
  }

  set infos(role){
    this._role = role
  }

}
