import Handlebars from 'handlebars'
import math from '../utils/math'
import moment from 'moment'
import {Hooks} from '../../'

export default function listPage(file, index, action, text) {
  var res = Hooks.instance.trigger('beforeListPage', file, index, action, text)
  res += `<tr>`
  res += `<td>${math(index, '+', 1)}</td>
        <td>
          <a href="/abe/${file.template}?filePath=${file.path}" class="file-path">
            ${file.path}
          </a>
        </td>`
  
  if(file.date){
    res += `<td align="center">
              ${moment(file.date).format('YYYY-MM-DD')}
            </td>`
  }

  var draftRes = Hooks.instance.trigger('afterListPageDraft', draftRes, file, index, action, text)

  res += draftRes
  
  res += `<td align="center">`

  if (file.published){
    res += `<a href="/abe/${file.template}?filePath=${file.published.filePath}" class="checkmark">&#10004;</a>`
  }
  res += `</td>
          <td align="center">
            <div class="row icons-action">
              <div class="col-xs-6">`
  
  if (this.published){
    if (action.unpublish){
      res += `<a href="/unpublish/?filePath=${file.path}"
                 title="${text.unpublish}"
                 class="icon" data-unpublish="true"data-text="${text.confirmUnpublish} {{file.path}}">
                <span class="glyphicon glyphicon-eye-close"></span>
              </a>`
    }
  }
          
  res += `</div>
          <div class="col-xs-6">`
      
  if(action.delete){
    res += `<a href="/delete/?filePath=${this.path}"
               title="${text.delete}"
               class="icon"
               data-delete="true"
               data-text="${text.confirmDelete} ${file.path}">
              <span class="glyphicon glyphicon-trash"></span>
            </a>`
  }

  res += `</div>
        </div>
      </td>
    </tr>`

  var res = Hooks.instance.trigger('afterListPage', res, file, index, action, text)

  return new Handlebars.SafeString(res)
}
